<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------+
| This is a modification/extension of the download
| sub-categories mod by carootje.
|
| Modified by TehDagda
|
| This page has been completely re-written to deal 
| with categories and downloads co-existing and to 
| provide easier navigation.  A download manager was
| also added allowing you to control download speed
| and file access.
|   - TehDagda 
|
| Updated 03/25/06 to fix broken image links.
| Updated 03/25/06 added a 'flat view' downloads page 
|         (downloads_simple.php).
| Updated 03/26/06 added external URL linking (links 
|         beginning with 'http' wll open in a new 
|         window).
| Updated 03/26/03 added page permissions based on 
|         the permissions set for 'downloads.php' in 
|         the Site Links section of the System 
|         Administration page.
+----------------------------------------------------*/


require_once "maincore.php";
include LOCALE.LOCALESET."downloads.php";
global $locale;

if ($data = dbarray(dbquery("SELECT link_visibility FROM ".$db_prefix."site_links WHERE link_url='downloads.php'"))) {
    if ($data['link_visibility'] > $userdata['user_level']) {fallback("index.php");}
}
if (isset($download_id) && !isNum($download_id)) {
    fallback("index.php");
}

// download manager
$download_speed = 500; // Kb/sec

if (isset($download_id)) {
    $res = 0;
    if ($data = dbarray(dbquery("SELECT download_url,download_cat FROM ".$db_prefix."downloads WHERE download_id='$download_id'"))) {
        $cdata = dbarray(dbquery("SELECT * FROM ".$db_prefix."download_cats WHERE download_cat_id='".$data['download_cat']."'"));
        if (checkgroup($cdata['download_cat_access']) || $data['download_cat'] == 0) {
            $res = 1;
        }
    }
    if ($res == 0) redirect("downloads.php");
        
    $requested_file = ltrim($data['download_url'], '/');

    // Hotlinked ULRLs
    $url_prefix = strtolower(substr($requested_file, 0, 4));
    if ($url_prefix == 'http' || $url_prefix == 'ftp:') {
        header('Location: '.$requested_file);
        exit;
    }

    // Load the file and pump it to the user.
    if (!is_file('./'.$requested_file)) {
	die('The file \''.$requested_file.'\' could not be found in '.realpath('./'.str_replace(basename($requested_file), '', $requested_file)).'. Please contact the webmaster (0)'); 
    }
    if (is_readable('./'.$requested_file)) {
        if ($download_file = fopen($requested_file, 'rb')) {
            $numbytes = $download_speed * 100;
            $filename = basename($requested_file);
            header('Content-type: '.$this_content_type);
            header('Content-disposition: attachment; filename='.$filename);
            header('Content-length: ' . filesize($requested_file));
            while ($read_data = fread($download_file, $numbytes)) {
                if (connection_aborted() === true) {
                    exit;
                } else {
                    echo $read_data;
                    usleep(100000); // wait 0.1 seconds before sending the next $numbytes bytes
                }
            }
            fclose($download_file);
            $result = dbquery("UPDATE ".$db_prefix."downloads SET download_count=download_count+1 WHERE download_id='$download_id'");
        } else {
            die('There was an error downloading the file.<br />If the problem persists, please contact the webmaster (1).'); //yes, i'm lazy :P
        }
    } else {
        die('There was an error downloading the file.<br />If the problem persists, please contact the webmaster (2).');
    }
    exit;
}

require_once "subheader.php";
require_once "side_left.php";

// Get an array of categories/files
function download_subcats($cat_id, $db_prefix) {
    $return = array();
    // Main category
    $result = dbquery("SELECT * FROM ".$db_prefix."download_cats WHERE download_cat_id='$cat_id'");
    $rows = dbrows($result);
    if ($rows != 0) {
        $data = dbarray($result);
        $return['main_' . $cat_id] ['catinfo'] = $data;
    }


    // Top categories
    $result = dbquery("SELECT * FROM ".$db_prefix."download_cats WHERE download_parent='$cat_id' ORDER BY download_cat_name");
    $rows = dbrows($result);
    if ($rows != 0) {
        while ($data = dbarray($result)) {
            if (checkgroup($data['download_cat_access'])) {
                $return ['main_' . $cat_id] ['files'] ['cat_' . $data['download_cat_id']] ['catinfo'] = $data;
            }
            // Sub categories
            $subresult = dbquery("SELECT * FROM ".$db_prefix."download_cats WHERE download_parent='".$data['download_cat_id']."' ORDER BY download_cat_name");
            $subrows = dbrows($subresult);
            if ($subrows != 0) {
                while ($subdata = dbarray($subresult)) {
                    if (checkgroup($subdata['download_cat_access'])) {
                        $return ['main_' . $cat_id] ['files'] ['cat_' . $data['download_cat_id']] ['files'] ['cat_' . $subdata['download_cat_id']] ['catinfo'] = $subdata;
                    }
                }
            }
        }
    }
    $tmp = $return;
    // Top files
    $result = dbquery("SELECT * FROM ".$db_prefix."downloads WHERE download_cat='$cat_id' ORDER BY download_title");
    $rows = dbrows($result);
    if ($rows != 0) {
        while ($data = dbarray($result)) {
            if (trim($data['download_filesize']) == '') {
                $data['download_filesize'] = 'N/A';
            }
            $return['main_' . $cat_id] ['files'] ['fil_' . $data['download_id']] = $data;
        }
    }
    // Main files
    if (is_array($tmp['main_' . $cat_id]['files'])) {
	foreach ($tmp['main_' . $cat_id]['files'] as $key => $subcat) {
	    //if ($key == 'catinfo') {return;}
            $thiskey = ltrim($key, 'cat_');
	    $result = dbquery("SELECT * FROM ".$db_prefix."downloads WHERE download_cat='$thiskey' ORDER BY download_title");
            $rows = dbrows($result);
	    if ($rows != 0) {
	        while ($data = dbarray($result)) {
                    if (trim($data['download_filesize']) == '') {
	                $data['download_filesize'] = 'N/A';
                    }
	            $return['main_' . $cat_id] ['files'] [$key] ['files'] ['fil_' . $data['download_id']] = $data;
                }
	    }
	}
        
            // Sub files
	    if (is_array($subcat['files'])) {
		foreach ($subcat['files'] as $subkey => $tmp2) {
		    $thissubkey = ltrim($subkey, 'cat_');
	            $subresult = dbquery("SELECT * FROM ".$db_prefix."downloads WHERE download_cat='$thissubkey' ORDER BY download_title");
		    $subrows = dbrows($subresult);
	            if ($subrows != 0) {
		        while ($subdata = dbarray($subresult)) {
	                    if (trim($subdata['download_filesize']) == '') {
		                $subdata['download_filesize'] = 'N/A';
	                    }
		            $return['main_' . $cat_id] ['files'] [$key] ['files'] [$subkey] ['files'] ['fil_' . $subdata['download_id']] = $subdata;
	                }
		    }
	        }
	    }
	}
	return $return;
    //}
}

// Always have a $cat_id
if (!isset($cat_id)) {
    $cat_id = 0;
}

$data = download_subcats($cat_id, $db_prefix);
//echo "<pre>";
//print_r($data);
//echo "</pre>";
//exit;

if (isset($data['main_' . $cat_id]['catinfo'])) {
    $extended_text = ": " . $data['main_' . $cat_id]['catinfo']['download_cat_name'];
} else {
    $extended_text = ': Main';
}

opentable($locale['400'] . $extended_text);
if (isset($data['main_' . $cat_id]['files'])) {
    echo "<table width='100%' cellspacing='0' cellpadding='0' class='tbl'>\n";
    foreach ($data['main_' . $cat_id]['files'] as $key => $maincat) {
        // Print the main categories
        if (substr($key, 0, 3) == 'cat') {
            $dldescription = $maincat['catinfo']['download_cat_description'];                        
            $dldescription = str_replace('&lt;br&gt;', '<br />', str_replace('&lt;br /&gt;', '<br />', $dldescription));                        
            $dldescription = stripslashes(parseubb($dldescription));
            echo "
        <tr>
            <td>
                <br />
            </td>
        </tr>
        <tr>
            <td valign='top'>
                <img src='images/folder.gif' />
                <a href='".FUSION_SELF."?cat_id=".$maincat['catinfo']['download_cat_id']."'>".$maincat['catinfo']['download_cat_name']."</a><br />
                <span class='small2'>
                    ".$dldescription."
                </span>
            </td>
        </tr>";
        // Print the main files
        } elseif (substr($key, 0, 3) == 'fil') {
            if ($data['main_' . $cat_id]['files'][$key]['download_filesize'] !== 'N/A') {
                $filesize = number_format($data['main_' . $cat_id]['files'][$key]['download_filesize']/1000, 2) . ' KB';
            } else {
                $filesize = $data['main_' . $cat_id]['files'][$key]['download_filesize'];
            }
            $dldescription = $data['main_' . $cat_id]['files'][$key]['download_description'];
            $dldescription = str_replace('&lt;br&gt;', '<br />', str_replace('&lt;br /&gt;', '<br />', $dldescription));                        
            $dldescription = stripslashes(parseubb($dldescription));            
            echo "
        <tr>
            <td>
                <br />
            </td>
        </tr>
        <tr>
            <td valign='top'>
                <img src='images/file.gif' />
                <a href='".FUSION_SELF."?cat_id=".$data['main_' . $cat_id]['files'][$key]['download_cat']."&download_id=".$data['main_' . $cat_id]['files'][$key]['download_id']."'>".$data['main_' . $cat_id]['files'][$key]['download_title']."</a><br />
                <span class='small2'>
                    ".dldescription."<br />
                    ".$locale['411']." ".$data['main_' . $cat_id]['files'][$key]['download_license']." | ".$locale['412']." ".$data['main_' . $cat_id]['files'][$key]['download_os']." | ".$locale['413']." ".$data['main_' . $cat_id]['files'][$key]['download_version']." | ".$locale['416']." ".$filesize."<br />
                    ".$locale['414']." ".showdate("%d.%m.%y", $data['main_' . $cat_id]['files'][$key]['download_datestamp'])." | ".$locale['415']." ".$data['main_' . $cat_id]['files'][$key]['download_count']."<br />
                </span>
            </td>
        </tr>";
        }
    }
    echo "</table>\n\n";
} else {
    echo $locale['432'];
}
closetable();
?>
<!--
+____________________________________________________+
| PHP-Fusion 6 Content Management System
+____________________________________________________+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+____________________________________________________+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+____________________________________________________+
| Downloads Sub-Categories Mod by TehDagda@9c0.com.
+____________________________________________________+
-->
<?php
require_once "side_right.php";
require_once "footer.php";
?>
